
//
//  PBoolEx.h - Packed Boolean Logic
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//      This is the rotation module header.
//
//  Created - 27 Dec, 2001 - James Leiterman
//
//  Modifications
//
//
//  stab = 4
//


#include    "CpuAsm.h"
#include    "KariType.h"                                // Master Definitions


#ifndef __PBoolEx_H
#define __PBoolEx_H

#ifdef __cplusplus
extern "C" {
#endif



void PBoolSetup( const CpuInfo * const pcinfo );


void vmp_pnotGeneric(  void * const pvD, const void * const pvA );
void vmp_pnotAsm(      void * const pvD, const void * const pvA );
void vmp_pnotAsmMMX(   void * const pvD, const void * const pvA );
void vmp_pnotAsmSSE2(  void * const pvD, const void * const pvA );
void vmp_pnotAsmSSE20( void * const pvD, const void * const pvA );

void vmp_pandGeneric(  void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pandAsm(      void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pandAsmMMX(   void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pandAsmSSE2(  void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pandAsmSSE20( void * const pvD, const void * const pvA, const void * const pvB );

void vmp_pandcGeneric( void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pandcAsm(     void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pandcAsmMMX(  void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pandcAsmSSE2( void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pandcAsmSSE20(void * const pvD, const void * const pvA, const void * const pvB );

void vmp_porGeneric(   void * const pvD, const void * const pvA, const void * const pvB );
void vmp_porAsm(       void * const pvD, const void * const pvA, const void * const pvB );
void vmp_porAsmMMX(    void * const pvD, const void * const pvA, const void * const pvB );
void vmp_porAsmSSE2(   void * const pvD, const void * const pvA, const void * const pvB );
void vmp_porAsmSSE20(  void * const pvD, const void * const pvA, const void * const pvB );

void vmp_pxorGeneric(  void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pxorAsm(      void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pxorAsmMMX(   void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pxorAsmSSE2(  void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pxorAsmSSE20( void * const pvD, const void * const pvA, const void * const pvB );

void vmp_pnorGeneric(  void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pnorAsm(      void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pnorAsmMMX(   void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pnorAsmSSE2(  void * const pvD, const void * const pvA, const void * const pvB );
void vmp_pnorAsmSSE20( void * const pvD, const void * const pvA, const void * const pvB );



#ifdef __cplusplus
}
#endif

#endif  //__PBoolEx_H





