        TITLE   Book prolX86.asm - Packed Rotation Left (X86)
        PAGE    53,160

;
; prolX86.asm - Packed Rotation Left
;
; This document contains file that you may use at your own risk in your own programs.
;
; This module is designed to accomodate X86 processors in the book.
;
;       NOTE: Needs masm 6.14 or later!
;
;       Created - 19 Dec 2001 - J.Leiterman
;
;       Modifications
;
;               
;
;       Tabs = 8



        .XLIST

        .387
        .686P
        .MMX
;       .K3D
        .model flat, C

        include x86.inc
        include KariType.inc
 
        .LIST



        .data

;;;externdef    llMaskBQ:qword, rrMaskBQ:qword

        public  llMaskBQ, rrMaskBQ

llMaskBQ dq     0ffffffffffffffffh
        dq      0fefefefefefefefeh
        dq      0fcfcfcfcfcfcfcfch
        dq      0f8f8f8f8f8f8f8f8h
        dq      0f0f0f0f0f0f0f0f0h
        dq      0e0e0e0e0e0e0e0e0h
        dq      0c0c0c0c0c0c0c0c0h
        dq      08080808080808080h
        dq      00000000000000000h      ; 8-(0...7)

rrMaskBQ dq     0ffffffffffffffffh
        dq      07f7f7f7f7f7f7f7fh
        dq      03f3f3f3f3f3f3f3fh
        dq      01f1f1f1f1f1f1f1fh
        dq      00f0f0f0f0f0f0f0fh
        dq      00707070707070707h
        dq      00303030303030303h
        dq      00101010101010101h
;;;     dq      00000000000000000h






prolX86  SEGMENT USE32 PUBLIC 'CODE'



;_________________________________________________________________________________________________
;=================================================================================================
;       Packed Rotate Left 16x8bit by n:{0...7}
;
;void vmp_prolB( uint8 * const pbD, const uint8 * const pbA, uint count )
;{
;       uint iCnt;
;       uint32 rmsk, lmsk;
;
;       count &= (8-1);                         // Clip count to data bit size -1
;       if ( count )
;         {
;               iCnt = 8-count;
;
;               rmsk = rrMaskBD[count];         // 7f
;               lmsk = llMaskBD[iCnt];          // 80
;
;               *(((uint32*)pbD)+0) = ((*(((uint32*)pbA)+0) & rmsk) << count)
;                               | ((*(((uint32*)pbA)+0) & lmsk) >> iCnt);
;               *(((uint32*)pbD)+1) = ((*(((uint32*)pbA)+1) & rmsk) << count)
;                               | ((*(((uint32*)pbA)+1) & lmsk) >> iCnt);
;               *(((uint32*)pbD)+2) = ((*(((uint32*)pbA)+2) & rmsk) << count)
;                               | ((*(((uint32*)pbA)+2) & lmsk) >> iCnt);
;               *(((uint32*)pbD)+3) = ((*(((uint32*)pbA)+3) & rmsk) << count)
;                               | ((*(((uint32*)pbA)+3) & lmsk) >> iCnt);
;         }
;       else
;         {
;               *(((uint32*)pbD)+0) = *(((uint32*)pbA)+0);
;               *(((uint32*)pbD)+1) = *(((uint32*)pbA)+1);
;               *(((uint32*)pbD)+2) = *(((uint32*)pbA)+2);
;               *(((uint32*)pbD)+3) = *(((uint32*)pbA)+3);
;         }
;}                                                                      
;       NOTE: As X86 packed shifting only supports 16/32/64 bits we have to mask for 8bit!
;
;       *** MMX version *** 128bit (un)aligned

        public  vmp_prolBAsmMMX
vmp_prolBAsmMMX       proc    near pbD:ptr, pbA:ptr, count:DWORD
        .MMX    
ASSERT_PTR(pbD)
ASSERT_PTR(pbA)

        mov     ecx,dword ptr count             ; # of bits to shift
        mov     edx,pbD
        mov     eax,pbA
        and     ecx,8-1                         ; Clip count to 0...7 bits

        movq    mm0,[eax+0]                     ; Read Data
        movq    mm1,[eax+8]                             
        mov     eax,8
        movd    mm4,ecx                         ; count
        sub     eax,ecx                         ; iCnt=8-count

        ; mm0=64bits mm1=64bits  mm2=# of bits to shift

        movq    mm2,mm0
        movq    mm3,mm1
        movd    mm5,eax                         ; iCnt

        pand    mm0,llMaskBQ[eax*8]             ; val&80
        pand    mm1,llMaskBQ[eax*8]
        pand    mm2,rrMaskBQ[ecx*8]             ; val&7f
        pand    mm3,rrMaskBQ[ecx*8]

        psrlq   mm0,mm5                         ; (val & 80) >> iCnt
        psrlq   mm1,mm5
        psllq   mm2,mm4                         ; (val & 7f) << count
        psllq   mm3,mm4

        por     mm0,mm2
        por     mm1,mm3

        movq    [edx+0],mm0                     ; Write Data
        movq    [edx+8],mm1

        ret
vmp_prolBAsmMMX endp



;_________________________________________________________________________________________________
;       Packed Rotate Left 16x8bit by 1
;
;void vmp_prol1B( uint8 * const pbD, const uint8 * const pbA )
;{
;       *(((uint32*)pbD)+0) = ((*(((uint32*)pbA)+0) & 0x7f7f7f7f) << 1 )
;                       | ((*(((uint32*)pbA)+0) & 0x80808080) >> 7 );
;       *(((uint32*)pbD)+1) = ((*(((uint32*)pbA)+1) & 0x7f7f7f7f) << 1 )
;                       | ((*(((uint32*)pbA)+1) & 0x80808080) >> 7 );
;       *(((uint32*)pbD)+2) = ((*(((uint32*)pbA)+2) & 0x7f7f7f7f) << 1 )
;                       | ((*(((uint32*)pbA)+2) & 0x80808080) >> 7 );
;       *(((uint32*)pbD)+3) = ((*(((uint32*)pbA)+3) & 0x7f7f7f7f) << 1 )
;                       | ((*(((uint32*)pbA)+3) & 0x80808080) >> 7 );
;}
;       NOTE: As X86 packed shifting only supports 16/32/64 bits we have to mask for 8bit!
;
;       *** MMX version *** 128bit (un)aligned

        public  vmp_prol1BAsmMMX
vmp_prol1BAsmMMX       proc    near pbD:ptr, pbA:ptr, count:DWORD
        .MMX    
ASSERT_PTR(pbD)
ASSERT_PTR(pbA)

        mov     edx,pbD
        mov     eax,pbA

        movq    mm0,[eax+0]                     ; Read Data
        movq    mm1,[eax+8]

        ; mm0=64bits mm1=64bits

        movq    mm2,mm0
        movq    mm3,mm1

        pand    mm0,llMaskBQ[7*8]                       ; val&80
        pand    mm1,llMaskBQ[7*8]
        pand    mm2,rrMaskBQ[1*8]                       ; val&7f
        pand    mm3,rrMaskBQ[1*8]

        psrlq   mm0,7                           ; (val & 80) >> 7
        psrlq   mm1,7
        psllq   mm2,1                           ; (val & 7f) << 1
        psllq   mm3,1

        por     mm0,mm2
        por     mm1,mm3

        movq    [edx+0],mm0                     ; Write Data
        movq    [edx+8],mm1
                
        ret
vmp_prol1BAsmMMX        endp



;_________________________________________________________________________________________________
;=================================================================================================
;       Packed Rotate Left 8x16bit by n:{0...15}
;
;void vmp_prolH uint16 * const phD, const uint16 * const phA, uint count )
;{
;       uint iCnt;
;       uint32 rmsk, lmsk;
;
;       count &= (16-1);                                // Clip count to data bit size -1
;       if ( count )
;         {
;               iCnt = 16-count;
;
;               rmsk = rrMaskHD[count];         // 7fff
;               lmsk = llMaskHD[iCnt];          // 8000
;
;               *(((uint32*)phD)+0) = ((*(((uint32*)phA)+0) & rmsk) << count)
;                                                       | ((*(((uint32*)phA)+0) & lmsk) >> iCnt);
;               *(((uint32*)phD)+1) = ((*(((uint32*)phA)+1) & rmsk) << count)
;                                                       | ((*(((uint32*)phA)+1) & lmsk) >> iCnt);
;               *(((uint32*)phD)+2) = ((*(((uint32*)phA)+2) & rmsk) << count)
;                                                       | ((*(((uint32*)phA)+2) & lmsk) >> iCnt);
;               *(((uint32*)phD)+3) = ((*(((uint32*)phA)+3) & rmsk) << count)
;                                                       | ((*(((uint32*)phA)+3) & lmsk) >> iCnt);
;         }
;       else
;         {
;               *(((uint32*)phD)+0) = *(((uint32*)phA)+0);
;               *(((uint32*)phD)+1) = *(((uint32*)phA)+1);
;               *(((uint32*)phD)+2) = *(((uint32*)phA)+2);
;               *(((uint32*)phD)+3) = *(((uint32*)phA)+3);
;         }
;}                                                                      
;       *** MMX version *** 128bit (un)aligned

        public  vmp_prolHAsmMMX
vmp_prolHAsmMMX       proc    near pwD:ptr, pwA:ptr, count:DWORD
        .MMX    
ASSERT_PTR(pwD)
ASSERT_PTR(pwA)

        mov     ecx,dword ptr count             ; # of bits to shift
        mov     edx,pwD
        mov     eax,pwA
        and     ecx,16-1                                ; Clip count to 0...7 bits

        movq    mm0,[eax+0]                     ; Read Data
        movq    mm1,[eax+8]                             

        mov     eax,16
        movd    mm4,ecx                         ; count
        sub     eax,ecx                         ; Note: if 16 then 0!

        ; mm0=64bits mm1=64bits  mm2=# of bits to shift

        movq    mm2,mm0
        movq    mm3,mm1
        movd    mm5,eax                         ; iCnt

        psllw   mm2,mm4                         ; val << count
        psllw   mm3,mm4
        psrlw   mm0,mm5                         ; val >> iCnt
        psrlw   mm1,mm5

        por     mm0,mm2
        por     mm1,mm3

        movq    [edx+0],mm0                     ; Write Data
        movq    [edx+8],mm1

        ret
vmp_prolHAsmMMX endp



;_________________________________________________________________________________________________
;       Packed Rotate Left 8x16bit by 1
;
;void vmp_prol1H( uint16 * const phD, const uint16 * const phA )
;{
;       uint32 val0, val1, val2, val3;
;
;       val0 = *(((uint32*)phA)+0);
;       val1 = *(((uint32*)phA)+1);
;       val2 = *(((uint32*)phA)+2);
;       val3 = *(((uint32*)phA)+3);
;
;       *(((uint32*)phD)+0) = ((val0 & 0x7fff7fff) << 1 )
;                                               | ((val0 & 0x80008000) >> 15);
;       *(((uint32*)phD)+1) = ((val1 & 0x7fff7fff) << 1 )
;                                               | ((val1 & 0x80008000) >> 15);
;       *(((uint32*)phD)+2) = ((val2 & 0x7fff7fff) << 1 )
;                                               | ((val2 & 0x80008000) >> 15);
;       *(((uint32*)phD)+3) = ((val3 & 0x7fff7fff) << 1 )
;                                               | ((val3 & 0x80008000) >> 15);
;}
;       *** MMX version *** 128bit (un)aligned

        public  vmp_prol1HAsmMMX
vmp_prol1HAsmMMX       proc    near phD:ptr, phA:ptr, count:DWORD
        .MMX    
ASSERT_PTR(phD)
ASSERT_PTR(phA)

        mov     edx,phD
        mov     eax,phA

        movq    mm0,[eax+0]                     ; Read Data
        movq    mm1,[eax+8]

        ; mm0=64bits mm1=64bits

        movq    mm2,mm0
        movq    mm3,mm1

        psrlw   mm0,15                          ; val >> 15
        psrlw   mm1,15
        psllw   mm2,1                           ; val << 1
        psllw   mm3,1

        por     mm0,mm2
        por     mm1,mm3

        movq    [edx+0],mm0                     ; Write Data
        movq    [edx+8],mm1
                
        ret
vmp_prol1HAsmMMX        endp



;_________________________________________________________________________________________________
;=================================================================================================
;       Packed Rotate Left 4x32bit by n:{0...31}
;
;void vmp_prolW( uint32 * const pwD, const uint32 * const pwA, uint count )
;{
;       uint iCnt;
;
;       count &= (32-1);                                // Clip count to data bit size -1
;
;       if (count)
;         {
;               iCnt = 32-count;
;
;               *(pwD+0) = (*(pwA+0) >> iCnt) | (*(pwA+0) << count);
;               *(pwD+1) = (*(pwA+1) >> iCnt) | (*(pwA+1) << count);
;               *(pwD+2) = (*(pwA+2) >> iCnt) | (*(pwA+2) << count);
;               *(pwD+3) = (*(pwA+3) >> iCnt) | (*(pwA+3) << count);
;         }
;       else
;         {
;               *(pwD+0) = *(pwA+0);
;               *(pwD+1) = *(pwA+1);
;               *(pwD+2) = *(pwA+2);
;               *(pwD+3) = *(pwA+3);
;         }
;}                                                                      
;       *** MMX version *** 128bit (un)aligned

        public  vmp_prolWAsmMMX
vmp_prolWAsmMMX       proc    near pwD:ptr, pwA:ptr, count:DWORD
        .MMX    
ASSERT_PTR(pwD)
ASSERT_PTR(pwA)

        mov     ecx,dword ptr count             ; # of bits to shift
        mov     edx,pwD
        mov     eax,pwA
        and     ecx,32-1                                ; Clip count to 0...7 bits

        movq    mm0,[eax+0]                     ; Read Data
        movq    mm1,[eax+8]                             

        mov     eax,32
        movd    mm4,ecx                         ; count
        sub     eax,ecx                         ; Note: if 32 then 0!
        
        ; mm0=64bits mm1=64bits  mm5=# of bits to shift

        movq    mm2,mm0
        movq    mm3,mm1
        movd    mm5,eax                         ; iCnt

        pslld   mm2,mm4                         ; val << count
        pslld   mm3,mm4
        psrld   mm0,mm5                         ; val >> iCnt
        psrld   mm1,mm5

        por     mm0,mm2
        por     mm1,mm3

        movq    [edx+0],mm0                     ; Write Data
        movq    [edx+8],mm1

        ret
vmp_prolWAsmMMX endp



;_________________________________________________________________________________________________
;       Packed Rotate Left 4x32bit by 1
;
;void vmp_prol1W( uint32 * const pwD, const uint32 * const pwA )
;{
;       *(pwD+0) = (*(pwA+0) >> 31) | (*(pwA+0) << 1);
;       *(pwD+1) = (*(pwA+1) >> 31) | (*(pwA+1) << 1);
;       *(pwD+2) = (*(pwA+2) >> 31) | (*(pwA+2) << 1);
;       *(pwD+3) = (*(pwA+3) >> 31) | (*(pwA+3) << 1);
;}
;       *** MMX version *** 128bit (un)aligned

        public  vmp_prol1WAsmMMX
vmp_prol1WAsmMMX       proc    near pwD:ptr, pwA:ptr, count:DWORD
        .MMX    
ASSERT_PTR(pwD)
ASSERT_PTR(pwA)

        mov     edx,pwD
        mov     eax,pwA

        movq    mm0,[eax+0]                     ; Read Data
        movq    mm1,[eax+8]

        ; mm0=64bits mm1=64bits

        movq    mm2,mm0
        movq    mm3,mm1

        psrld   mm0,31                          ; val >> 31
        psrld   mm1,31
        pslld   mm2,1                           ; val << 1
        pslld   mm3,1

        por     mm0,mm2
        por     mm1,mm3

        movq    [edx+0],mm0                     ; Write Data
        movq    [edx+8],mm1
                
        ret
vmp_prol1WAsmMMX        endp



prolX86  ends
        end




