
//
//  FasX86.cpp - (Scalar) Addition & Subtraction
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include "KariType.h"                                   // Master Definitions

    //  3rd Party Libraries
    
#include    <assert.h>
#include    <iostream.h>
#include    <math.h>

    //  Book Development Library Modules

#include    "CpuAsm.h"                                  // CPU
#include    "vmp3D.h"
#include    "vmp3DEx.h"
#include    "Fas.h"                                 // Addition & Subtraction
#include    "FasEx.h"                                   //  "           "           Extra



//
//  Setup module
//
//  NOTE: This function sets up the function vectors so the best function
//      is attached to the vector for the processor running.
//

void FasSetup( const CpuInfo * const pcinfo )
{
    ASSERT_PTR4(pcinfo);

    if ( CPUBITS_SSE & pcinfo->nBits )
      {
        vmp_FAdd =              vmp_FAddAsmSSE;
        vmp_FSub =              vmp_FSubAsmSSE;
      }

    else if ( CPUBITS_3DNOW & pcinfo->nBits )
      {
        vmp_FAdd =              vmp_FAddAsm3DNow;
        vmp_FSub =              vmp_FSubAsm3DNow;
      }
    
    else
      {
        vmp_FAdd =              vmp_FAddGeneric;
        vmp_FSub =              vmp_FSubGeneric;
      }
}





