  
//
//  QVmd3D.h - (Quad) 3D Math Multiplication & Division
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to accomodate the book.
//
//      This module is designed for fast 3D math
//
//  Created - 3 Oct 2001 - James Leiterman
//
//  Last Modification
//
//  stab=4
//


#include    "KariType.h"                                // Kari Games Master Definitions
#include    "vmp3D.h"


#ifndef __QVmd3D_H
#define __QVmd3D_H

#ifdef __cplusplus
extern "C" {
#endif



//
//  Product (Multiplication)
//
typedef void (*vmp_QVecMulProc)( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB);
extern vmp_QVecMulProc vmp_QVecMul;
extern vmp_QVecMulProc vmp_QVecMul0;



//
//  (Quad) Scale (Scalar Multiplication)
//

typedef void (*vmp_QVecScaleProc)(vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScale );
extern vmp_QVecScaleProc vmp_QVecScale;
extern vmp_QVecScaleProc vmp_QVecScale0;



//
//  Product (Multiplication-Addition)
//
typedef void (*vmp_QVecMAddProc)( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);
extern vmp_QVecMAddProc vmp_QVecMAdd;
extern vmp_QVecMAddProc vmp_QVecMAdd0;



//
//  Product (Multiplication-Subtraction)
//
typedef void (*vmp_QVecMSubProc)( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, const vmp3DQVector * const pvB, const vmp3DQVector * const pvC);
extern vmp_QVecMSubProc vmp_QVecMSub;
extern vmp_QVecMSubProc vmp_QVecMSub0;



//
//  Product (Division)
//
typedef void (*vmp_QVecDivProc)( vmp3DQVector * const pvD, const vmp3DQVector * const pvA, float fScalar);
extern vmp_QVecDivProc vmp_QVecDiv;
extern vmp_QVecDivProc vmp_QVecDiv0;
extern vmp_QVecDivProc vmp_QVecDivFast;
extern vmp_QVecDivProc vmp_QVecDivFast0;



//
//  (Quad) Dot Product
//
typedef void (*vmp_QDotProductProc)(float * const pfD, const vmp3DQVector * const vA, const vmp3DQVector * const vB);
extern vmp_QDotProductProc vmp_QDotProduct;
extern vmp_QDotProductProc vmp_QDotProduct0;



//
//  (Quad) Cross Product
//
typedef void (*vmp_QCrossProductProc)(vmp3DQVector * const vD, const vmp3DQVector * const vA, const vmp3DQVector * const vB);
extern vmp_QCrossProductProc vmp_QCrossProduct;
extern vmp_QCrossProductProc vmp_QCrossProduct0;



#ifdef __cplusplus
}
#endif

#endif  //__QVmd3D_H


