
//
//  ase.h - *.ASE file parser
//
//  This document contains file that you may use at your own risk in your own programs.
//
//  This module is designed to work with the exercises for this book.
//
//      This is the memory, file, management, module header.
//
//  Created - 13 Mar, 2002 - James Leiterman
//
//  Last Modification
//
//  stab=4
//



#ifndef ase_H
#define ase_H


#include    "aseEx.h"


#ifdef __cplusplus
    extern "C" {
#endif


typedef struct rdbPosType
{
    uint            nCnt;
    uint            nIndex;
} rdbPos;



//
//  Relational Database 
//
typedef struct rdbInfoType
{
    uint            nTotShapeCnt;
    uint            nTotShapeVertexCnt;
    rdbPos          *pShapeLookup;
    vmp3DQDVector   *pVertShapeList;



} rdbInfo;



//
//  Function Prototypes
//

bool aseParse( const char * pStr, ulong uipSize, Node * pHead, rdbInfo *pStat );

bool aseRDB( const Node * pNode, rdbInfo *pStat );

bool aseWriteTextureC( const char * pszFPath, const Node * pNode );

void aseDump( const Node * pNode );



#ifdef __cplusplus
}
#endif

#endif  //ase_H
