
;
; KariType.inc - Master Definitions
;
; This document contains file that you may use at your own risk in your own programs.
;
; This module is designed to work with the exercises for this book.
;
;  Created - 2 Jun 98 - James Leiterman
;
;  Modifications
;
;   Tabs = 8 (Note: The code actually used in book has no tabs, only spaces!)
;


;;;        .387
;;;     .586P   .586    .686   .686P
;;;      .K3D    .XMM    .MMX



ifndef __KariTypeInc
__KariTypeInc   equ     1


        BUILD_VMP_DEBUG =       1
;       BUILD_VMP_FINAL =       1



ifdef   BUILD_VMP_DEBUG
        USE_ASSERT      =       1
endif




false   =       0
true    =       1


    ;
    ;   yes : no conditional
    ;

NO      =       false
YES     =       true




    ;   Tri-State
    ;   Use in that rare case where a 3 state return value is needed!

TriFail =       -1              ; fail condition
TriNull =       0               ; not a fail but not successful
TriTrue =       1               ; successful condition



    ;
    ;   Assembly Specific!
    ;

arg1    equ     8               ; Argument #1
arg2    equ     (arg1+4)        ; Argument #2
arg3    equ     (arg2+4)        ; Argument #3
arg4    equ     (arg3+4)        ; Argument #4
arg5    equ     (arg4+4)        ; Argument #5
arg6    equ     (arg5+4)        ; Argument #6
arg7    equ     (arg6+4)        ; Argument #7
arg8    equ     (arg7+4)        ; Argument #8
arg9    equ     (arg8+4)        ; Argument #9
arg10   equ     (arg9+4)        ; Argument #10



;
;       Assert if Pointer is n=NULL
;
ASSERT_PTR      MACRO   arg1
ifdef USE_ASSERT
        test    arg1,0FFFFFFFFh
        jnz     $+3                     ; Hop over breakpoint

        int     3                       ; Break
endif
endm



;
;       Assert if Pointer is n=NULL
;
ASSERT_PTR4     MACRO   arg1
ifdef USE_ASSERT
        test    arg1,0FFFFFFFFh
        jnz     $+3                     ; Hop over breakpoint

        int     3                       ; Break

        test    arg1,000000003h
        jz      $+3                     ; Hop over breakpoint

        int     3                       ; Break
endif
endm



;
;       Assert if Pointer is n=NULL
;
ASSERT_PTR16    MACRO   arg1
ifdef USE_ASSERT
        test    arg1,0FFFFFFFFh
        jnz     $+3                     ; Hop over breakpoint

        int     3                       ; Break

        test    arg1,00000000Fh
        jz      $+3                     ; Hop over breakpoint

        int     3                       ; Break
endif
endm


;
;       Assert if value is zero!
;
ASSERT_ZERO     MACRO   arg1
ifdef USE_ASSERT
        test    arg1,0FFFFFFFFh
        jnz     $+3                     ; Hop over breakpoint

        int     3                       ; Break
endif
endm

;
;       Assert if value is zero!
;
ASSERT_FZERO    MACRO   arg1
ifdef USE_ASSERT
        test    arg1,0FFFFFFFFh
        jnz     $+3                     ; Hop over breakpoint

        int     3                       ; Break
endif
endm



;
;       Assert if negative (n<0)
;
ASSERT_NEG      MACRO   arg1
ifdef USE_ASSERT
        test    arg1,080000000h
        jz      $+3                     ; Hop over breakpoint

        int     3                       ; Break
endif
endm


;
;       Assert if negative (n<0)
;
ASSERT_FNEG     MACRO   arg1
ifdef USE_ASSERT
        test    arg1,080000000h
        jz      $+3                     ; Hop over breakpoint

        int     3                       ; Break
endif
endm






endif   ;   __KariTypeInc

